#-----------------------------------------------------------------------------------------------#
# ScriptName : SetWallpaper.ps1                                                                 #
# Description : Force a Desktop wallpaper Refresh                                               #
#-----------------------------------------------------------------------------------------------#

# script tournant en tâche de fond et vérifiant la présence d'une connexion veyon-server sur le poste
# un fond d'écran d'avertissement est affiché en cas de surveillance

$imgPath="C:\Windows\Web\SE4\wallpaper.jpg"
$imgPathVeyon="C:\Windows\Web\SE4\veyon.jpg"
$code = @'
using System.Runtime.InteropServices;
namespace Win32{
    public class Wallpaper{
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        static extern int SystemParametersInfo (int uAction , int uParam , string lpvParam , int fuWinIni);
        public static void SetWallpaper(string thePath){
            SystemParametersInfo(20,0,thePath,3);
        }
    }
 }
'@
Add-Type -TypeDefinition $code

# Fonction : Modifier le fond d'écran
function Set-Wallpaper {
    param($imagePath)

    # Crée la clé si elle n'existe pas
    $regPath = "HKCU:\Control Panel\Desktop"
    If (!(Test-Path $regPath)) {
        New-Item -Path $regPath -Force
    }

    # Change la valeur du fond d'écran
    Set-ItemProperty -Path $regPath -Name "Wallpaper" -Value $imagePath
    Set-ItemProperty -Path $regPath -Name "WallpaperStyle" -Value 2 # 2 = Ajuster (Fit)

    # Appliquer immédiatement le fond d'écran
    rundll32.exe user32.dll, UpdatePerUserSystemParameters
}

$Veyon=$false
Set-Wallpaper -imagePath $imgPath
[Win32.Wallpaper]::SetWallpaper($imgPath)
While ($true) {
    $connections = Get-NetTCPConnection -LocalPort 11100 -State Established -ErrorAction SilentlyContinue
    If ($connections -and -not $Veyon) {
        # Changer le fond d'écran
        Set-Wallpaper -imagePath $imgPathVeyon
        [Win32.Wallpaper]::SetWallpaper($imgPathVeyon)
        $Veyon=$true
    } ElseIf (-not $connections -and $Veyon) {
        # Changer le fond d'écran
        Set-Wallpaper -imagePath $imgPath
        [Win32.Wallpaper]::SetWallpaper($imgPath)
        $Veyon=$false
    }
    # Attendre 5 secondes avant la prochaine vérification
    Start-Sleep -Seconds 5
}
